import gtk
import gobject
from rhpl.translate import _, N_,textdomain
#from rhpl.xhwstate import *
import string

TRUE = 1
FALSE = 0

class VideocardDialog:
    #TODO: Is this list correct?
    drivers = ["mga", "ati", "chips", "cirrus", "cyrix", "fbdev",
               "glint", "i128", "i740", "i810", "mga", "neomagic",
               "newport", "nv", "r128", "radeon", "rendition", "s3",
               "s3virge", "savage", "siliconmotion", "sis", "tdfx",
               "trident", "tseng", "vesa", "vga", "vmware"]

    def __init__(self, xml, videocard, hardware_state):
        self.xml = xml
        self.videocard = videocard
        self.hardware_state = hardware_state
 
        xml.get_widget("videocard_icon").set_from_file("/usr/share/redhat-config-xfree86/pixmaps/videocard.png")

        self.changing_selection = 0
        
        dialog = xml.get_widget("videocard_dialog")
        dialog.set_transient_for(xml.get_widget("display_dialog"))
        dialog.set_modal(TRUE)

##         optionmenu = xml.get_widget("videocard_mem_option_menu")
##         menu = gtk.Menu()
##         for ram in videocard.possible_ram_sizes():
##             if ram % 1024 != 0:
##                 m = (ram, repr(ram) +" Kb")
##             else:
##                 m = (ram, repr(ram/1024) +" Mb")
##             item = gtk.MenuItem(m[1])
##             item.set_data("mem-size", m[0])
##             item.show()
##             menu.append(item)
##         optionmenu.set_menu(menu)

#        xml.get_widget("videocard_driver_combo"). set_popdown_strings(self.drivers)

        videocard_store = gtk.ListStore(gobject.TYPE_STRING)
        self.videocard_store = videocard_store

        iter = videocard_store.append()
        videocard_store.set_value(iter, 0, "Custom")
        card_list = videocard.cardsDB().keys()
        card_list.sort()

#        primary = self.videocard.primaryCard()
#        carddata = primary.getCardData()
#        default_name = carddata["NAME"];
        default_name = self.hardware_state.get_videocard_name()

        for name in card_list:
            iter = videocard_store.append()
            videocard_store.set_value(iter, 0, name)

            if name == default_name:
                self.probed_path = videocard_store.get_path(iter)

        self.tree_view = xml.get_widget("videocard_tree")
        self.tree_view.set_model(videocard_store)
        selection = self.tree_view.get_selection()
        # Select the first before setting up callback, to avoid first callback.
        selection.select_iter(videocard_store.get_iter_first())
        selection.connect("changed", self.selection_changed)

        self.vc_col = gtk.TreeViewColumn(None, gtk.CellRendererText(), text=0)
        self.tree_view.append_column(self.vc_col)

        self.type_entry = xml.get_widget("videocard_type_entry")
        self.driver_entry = xml.get_widget("videocard_driver_entry")
#        self.mem_check = xml.get_widget("videocard_mem_check")
#        self.mem_optionmenu = xml.get_widget("videocard_mem_option_menu")

#        self.mem_check.connect("toggled", self.custom_mem_toggled)

        button = xml.get_widget("videocard_probe_button")
        button.connect("clicked", self.probe_videocard)
        primary = videocard.primaryCard()
        button.set_sensitive(primary != None and primary.getCardData() != None)

        self.hydrate(self.hardware_state)

#    def parse_lines(self, lines):
#        for line in string.split(lines, "\n"):
#            items = self.hardware_state.tokenize_line(line)
#            if len(items) == 2 and string.upper(items[0]) == "VIDEORAM":
#                self.set_custom_memory(TRUE)
#                self.set_memory_size(string.atoi(items[1]))

    def goto_row(self, cardname):
        self.tree_view.expand_row(self.probed_path[0], TRUE)
        self.changing_selection = 1
        selection = self.tree_view.get_selection()
        iter = self.videocard_store.get_iter(self.probed_path)

        selection.select_iter(iter)
        self.changing_selection = 0
        self.tree_view.set_cursor(self.probed_path, self.vc_col, FALSE)
        self.tree_view.scroll_to_cell(self.probed_path, self.vc_col, TRUE, 0.5, 0.0)
        
    def set_card_data(self, carddata, goto_row):
        name = carddata["NAME"];
#        self.type_entry.set_text(name)
#        self.set_custom_memory(FALSE)
        if goto_row:
            self.goto_row(name)
        if carddata.has_key("LINE"):
            lines = carddata["LINE"]
#            self.parse_lines(lines)

    def probe_videocard(self, widget):
        if self.probed_path:
            self.goto_row(self.probed_path)
#        primary = self.videocard.primaryCard()
#        carddata = primary.getCardData()
#        self.set_card_data(carddata, 1)

    def custom_mem_toggled(self, checkbutton):
        self.mem_optionmenu.set_sensitive(checkbutton.get_active())

##     def set_custom_memory(self, custom):
##         if custom:
##             self.mem_check.set_active(TRUE)
##             self.mem_optionmenu.set_sensitive(TRUE)
##         else:
##             self.mem_check.set_active(FALSE)
##             self.mem_optionmenu.set_sensitive(FALSE)

##     def set_memory_size(self, size):
##         if size == 0:
##             return
        
##         ram_sizes = self.videocard.possible_ram_sizes()
##         try:
##             index = ram_sizes.index(size)
##             self.mem_optionmenu.set_history(index)
##         except:
##             print _("Warning: Unknown videoram size %d!")%(size)

##     def get_memory_size(self):
##         if self.mem_check.get_active():
##             ram_sizes = self.videocard.possible_ram_sizes()
##             index = self.mem_optionmenu.get_history()
##             return ram_sizes[index]
##         return 0

    def selection_changed(self, selection):
        if self.changing_selection:
            return
        (store, iter) = selection.get_selected()
        if iter == None:
            return
        name = self.videocard_store.get_value(iter, 0)

        if self.videocard.cardsDB().has_key(name):
            carddata = self.videocard.cardsDB()[name]
            self.set_card_data(carddata, 0)
        
    def hydrate(self, state):
        name = state.get_videocard_name()
#        self.type_entry.set_text(name)
        self.goto_row(name)
#        self.driver_entry.set_text(state.get_videocard_driver())
#        self.set_memory_size(state.get_videocard_ram_or_probed())
#        self.set_custom_memory(state.get_videocard_ram() != 0)

    def dehydrate(self, state):
        (store, iter) = self.tree_view.get_selection().get_selected()
        if iter == None:
            return
        name = self.videocard_store.get_value(iter, 0)
        carddata = self.videocard.cardsDB()[name]
        driver = carddata["DRIVER"]

        state.set_videocard_name(name)
        state.set_videocard_driver(driver)
        
#        state.set_videocard_name(self.type_entry.get_text())
#        state.set_videocard_driver(self.driver_entry.get_text())
#        state.set_videocard_ram(self.get_memory_size())
        
    def run(self):
        dialog = self.xml.get_widget("videocard_dialog")
        dialog.set_position(gtk.WIN_POS_CENTER_ON_PARENT)
        dialog.present()
        while 1:
            res = dialog.run()
            
            if res != gtk.RESPONSE_OK:
                dialog.hide()
                return FALSE
            
            break
        
        dialog.hide()
        return TRUE

